/* killall a kick 
 * by Marek Zelem
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <signal.h>
#include <string.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <mmm/text.h>
#include <mmm/net_lib.h>
#include "computer.h"

/* inicializacia */

int testsuser( char *t )
{ int n;
  char c;
	n=0;
	while( t[n]!=0 && t[n]!=':' )	n++;
	c=t[n]; t[n]=0;
	if(	!strcmp("zelem@decef",t)
		|| !strcmp("marek@fornax",t)
	  )
	{	t[n]=c;
		return(1);
	}
	t[n]=c;
	return(0);
}

int foreach_process( int(*func)(int pid, char *cmd, long d), long d )
{ DIR *dir;
  struct dirent *de;
  int n,pid,fd,i;
  char buf[128];
	if( (dir=opendir("/proc/"))==NULL )	return(-1);
	n=0;
	while( (de=readdir(dir))!=NULL )
	{	if( de->d_name[0]<'0' || de->d_name[0]>'9' )
			continue;
		pid=atoi(de->d_name);
		sprintf(buf,"/proc/%d/cmdline",pid);
		if( (fd=open(buf,O_RDONLY))<0 )	continue;
		i=read(fd,buf,127);
		buf[(i>0)?i:0]='\0';
		close(fd);
		if( func(pid,buf,d)>0 )	n++;
	}
	closedir(dir);
	return(n);
}

int pf_killall( int pid, char *cmd, long d )
{ char *ctk,*p;
	ctk=(char*)d;
	if( (p=strrchr(cmd,'/'))==NULL )
		p=cmd;
	else	p++;
//printf("Proces: <%s>\n",p);
	if( !strcmp(p,ctk) )
	{	kill(pid,SIGTERM);
		return(1);
	}
	return(0);
}

int pf_kick( int pid, char *cmd, long d )
{ char buf[32];
  struct stat s;
	sprintf(buf,"/proc/%d",pid);
	if( stat(buf,&s)>=0 && s.st_uid==d )
	{	kill(pid,SIGTERM);
		return(1);
	}
	return(0);
}

int killall_init( void )
{	return(0);
}

int killall_func( int sock, char *input )
{ char *p;
  int i;
	if( (p=strstr(input,"killall"))!=NULL && (p=strchr(p,' '))!=NULL
		&& testsuser(input) )
	{ int fd[2];
	  char *pp;
		while( *p==' ' )	p++;
		if( (pp=strchr(p,' '))!=NULL )	*pp=0;
		if( pipe(fd)<0 )	goto My_killall;
		switch( fork() )
		{  case -1:	close( fd[0] );
				close( fd[1] );
My_killall:			i=foreach_process(pf_killall,(long)p);
				net_printf(sock,
//				"%d procesov kill-nutych!\n",i);
				"%d processes killed!\n",i);
				break;
		   case 0:
			{	close(1);
				close(2);
				dup(fd[1]);
				dup(fd[1]);
				close(fd[0]);
				close(0);
				execl("/bin/killall","killall","-9",p,NULL);
				net_printf(0,"Can't execute killall\n");
				exit(0);
			}
		   default:
		   	{ int l;
			  char buf[1024];
				close(fd[1]);
				l=read(fd[0],buf,1024);
				if( l>0 )
					write(sock,buf,l);
				close(fd[0]);
			}
		}
		return(1);
	}
	else if( (p=strstr(input,"kick"))!=NULL && (p=strchr(p,' '))!=NULL
		&& testsuser(input) )
	{ struct passwd *pw;
	  char *pp;
		while( *p==' ' )	p++;
		if( (pp=strchr(p,' '))!=NULL )	*pp=0;
		pw=getpwnam(p);
		if( pw==NULL )
		{	net_printf(sock,"Unknown user: %s\n",p);
			return(1);
		}
		switch( fork() )
		{  case -1:	
				i=foreach_process(pf_kick,pw->pw_uid);
				net_printf(sock,"User %s kicked,"
					" %d processes killed\n",p,i);
				goto Err;
		   case 0:
		   	setuid(pw->pw_uid);
			kill(-2,SIGKILL);
			exit(0);
		   default:
		   	net_printf(sock,"User %s kicked\n",p);
		}
		return(1);
	}
	else if( (p=strstr(input,"nudzovy inetd"))!=NULL
		&& testsuser(input) )
	{ int fd,pid;
	  char buf[32];
	  	pid=-1;
		if( (fd=open("/var/run/inetd.pid",O_RDONLY))>=0 )
		{  if( (i=read(fd,buf,31))>0 )
		   {	buf[i]=0;
		   	pid=atoi(buf);
		   }
		   close(fd);
		}
		if( pid>0 )	kill(pid,SIGKILL);
		switch( fork() )
		{	case -1:	goto Err;
			case 0:	
				execl("/usr/sbin/inetd","inetd",
					"/etc/nudzovy.inetd.conf",NULL);
				exit(0);
			default:
				net_printf(sock,"Pouzi port 22768\n");
		}
		return(1);
	}
	else if( (p=strstr(input,"sprav reboot"))!=NULL
		&& testsuser(input) )
	{	kill(2,1);
		net_printf(sock,"Rebooting...\n");
		return(1);
	}
	return(-1);
Err:	net_printf(sock,"fork error!\n");
	return(1);
}

